function Queue()
{
	return new ScriptObject()
	{
		__ref = 0;
		class = "QueueObject";
		min = 0;
		max = -1;
	};
}

function QueueObject::onRemove(%this)
{
	for (%i = %this.min; %i <= %this.max; %i++)
		unref(%this.value[%i]);
}

function QueueObject::length(%this)
{
	return (%this.max - %this.min) + 1;
}

function QueueObject::clear(%this)
{
	for (%i = %this.min; %i <= %this.max; %i++)
	{
		unref(%this.value[%i]);
		%this.value[%i] = "";
	}

	%this.min = 0;
	%this.max = -1;
}

function QueueObject::push(%this, %value)
{
	%this.value[%this.max++] = ref(%value);
}

function QueueObject::pop(%this)
{
	if (%this.max < %this.min)
		return "";

	%value = %this.value[%this.min];

	%this.value[%this.min] = "";
	%this.min++;

	if (%this.min > %this.max)
	{
		%this.min = 0;
		%this.max = -1;
	}

	return unref(%value);
}